
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
   Two event handlers for two buttons.
   Start the GUI the correct way:
   https://docs.oracle.com/javase/tutorial/uiswing/concurrency/initial.html
*/
public class SimpleGUIProgram_v9
{
   public static void createAndShowGUI()
   {
      System.out.println("hello");
      JFrame jf = new JFrame("Simple GUI Program v10");
      jf.setLayout(new FlowLayout());
      JButton jb1 = new JButton("Hello 1");
      JButton jb2 = new JButton("Hello 2");
      jb1.addActionListener(new ActionHandler_v9a());
      jb2.addActionListener(new ActionHandler_v9b());
      jf.add(jb1);
      jf.add(jb2);
      jf.setSize(400, 400);
      jf.setVisible(true);
      System.out.println("bye 2");
   }

   public static void main(String[] args) throws Exception
   {
      SwingUtilities.invokeLater(new Runnable() {
          public void run() {
              createAndShowGUI();
      }});
      //Thread.sleep(1);
      System.out.println("bye 1");
   }
}


class ActionHandler_v9a implements ActionListener
{
   public int count = 0;

   // There is only one method in the ActionListener interface
   public void actionPerformed(ActionEvent e)
   {
      ++count;
      System.out.println("Ouch " + count + ".");
   }
}


class ActionHandler_v9b implements ActionListener
{
   public int count = 0;

   // There is only one method in the ActionListener interface
   public void actionPerformed(ActionEvent e)
   {
      --count;
      System.out.println("Ouch " + count + ".");
   }
}

