/*
   Instantiate a JFrame on the main() thread instead of on
   the Event Dispatch Thread (EDT). Notice that the number of
   initial ComponentEvent events can vary from 0 to 4! This
   is a race condition between the main() thread and the EDT.
*/

import javax.swing.JFrame;
import javax.swing.JLabel;
import java.awt.FlowLayout;
import java.awt.event.ComponentListener;
import java.awt.event.ComponentEvent;


public class TestEventDispatchThread_v1
{
   public TestEventDispatchThread_v1() throws Exception
   {
      final JFrame jf = new JFrame("Test EDT v1");
      jf.setLocationByPlatform(true);
      jf.setVisible(true);
      jf.setSize(500, 500);
      jf.setLayout(new FlowLayout());
      jf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      Thread.sleep(22);
      jf.add(new JLabel("hello"));
      jf.addComponentListener( new ComponentHandler_v1() );
   }


   public static void main(String[] args) throws Exception
   {
      new TestEventDispatchThread_v1();
   }
}


class ComponentHandler_v1 implements ComponentListener
{
   // There are four methods in the ComponentListener interface.
   public void componentMoved(  ComponentEvent e){System.out.println(e);}
   public void componentHidden( ComponentEvent e){System.out.println(e);}
   public void componentShown(  ComponentEvent e){System.out.println(e);}
   public void componentResized(ComponentEvent e){System.out.println(e);}
}
