/*
   Here is a way to instantiate a JFrame on the
   EDT (Event Dispatch Thread). Notice that this
   program always begins with six ComponentEvent
   events
*/

import javax.swing.JFrame;
import javax.swing.JLabel;
import java.awt.FlowLayout;
import java.awt.event.ComponentListener;
import java.awt.event.ComponentEvent;


public class TestEventDispatchThread_v11
{
   public TestEventDispatchThread_v11()
   {
      final JFrame jf = new JFrame("Test EDT v11");
      jf.setLocationByPlatform(true);
      jf.setVisible(true);
      jf.setSize(500, 500);
      jf.setLayout(new FlowLayout());
      jf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    //try{Thread.sleep(2200);}catch(Exception e){}
      jf.add(new JLabel("hello"));
      jf.addComponentListener( new ComponentHandler_v11() );
   }


   public static void main(String[] args)
   {
      javax.swing.SwingUtilities.invokeLater(
         () -> new TestEventDispatchThread_v11() // lambda expression
      );
   }
}


class ComponentHandler_v11 implements ComponentListener
{
   // There are four methods in the ComponentListener interface.
   public void componentMoved(  ComponentEvent e){System.out.println(e);}
   public void componentHidden( ComponentEvent e){System.out.println(e);}
   public void componentShown(  ComponentEvent e){System.out.println(e);}
   public void componentResized(ComponentEvent e){System.out.println(e);}
}
