/*
   Here is a way to instantiate a JFrame on the
   EDT (Event Dispatch Thread). Notice that this
   program always begins with six ComponentEvent
   events
*/

import javax.swing.JFrame;
import javax.swing.JLabel;
import java.awt.FlowLayout;
import java.awt.event.ComponentListener;
import java.awt.event.ComponentEvent;

@SuppressWarnings("serial")
public class TestEventDispatchThread_v14 extends JFrame
{
   public TestEventDispatchThread_v14()
   {
      super("Test EDT v14");
      this.setLocationByPlatform(true);
      this.setVisible(true);
      this.setSize(500, 500);
      this.setLayout(new FlowLayout());
      this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    //try{Thread.sleep(2200);}catch(Exception e){}
      this.add(new JLabel("hello"));
      this.addComponentListener( new ComponentListener() // anonymous inner class
      {
         // There are four methods in the ComponentListener interface.
         public void componentMoved(  ComponentEvent e){System.out.println(e);}
         public void componentHidden( ComponentEvent e){System.out.println(e);}
         public void componentShown(  ComponentEvent e){System.out.println(e);}
         public void componentResized(ComponentEvent e){System.out.println(e);}
      });
   }

   public static void main(String[] args)
   {
      javax.swing.SwingUtilities.invokeLater(
         () -> new TestEventDispatchThread_v14() // lambda expression
      );
   }
}
