/*
   Instantiate a JFrame on the main() thread instead of on
   the Event Dispatch Thread (EDT). Notice that the number of
   initial ComponentEvent events can vary from 0 to 4! This
   is a race condition between the main() thread and the EDT.
*/

import javax.swing.JFrame;
import javax.swing.JLabel;
import java.awt.FlowLayout;
import java.awt.event.ComponentListener;
import java.awt.event.ComponentEvent;

@SuppressWarnings("serial")
public class TestEventDispatchThread_v2 extends JFrame
{
   public TestEventDispatchThread_v2() throws Exception
   {
      super("Test EDT v2");
      this.setLocationByPlatform(true);
      this.setVisible(true);
      this.setSize(500, 500);
      this.setLayout(new FlowLayout());
      this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      Thread.sleep(22);
      this.add(new JLabel("hello"));
      this.addComponentListener( new ComponentHandler_v2() );
   }


   public static void main(String[] args) throws Exception
   {
      new TestEventDispatchThread_v2();
   }
}


class ComponentHandler_v2 implements ComponentListener
{
   // There are four methods in the ComponentListener interface.
   public void componentMoved(  ComponentEvent e){System.out.println(e);}
   public void componentHidden( ComponentEvent e){System.out.println(e);}
   public void componentShown(  ComponentEvent e){System.out.println(e);}
   public void componentResized(ComponentEvent e){System.out.println(e);}
}
