import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.layout.Pane;
import javafx.scene.control.Label;
import javafx.scene.control.Button;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;

public class ButtonViewer extends Application
{
   public void start(Stage stage)
   {
      Label label = new Label("Hello, World!");
      label.relocate(0, 50);
      Button button = new Button("Click me!");
      EventHandler<ActionEvent> handler = new ClickHandler();
      button.setOnAction(handler);
      button.setOnAction(event->System.out.println("Clicked!"));

      Pane root = new Pane(button, label);
      final int PANE_WIDTH = 300;
      final int PANE_HEIGHT = 400;
      root.setMinSize(PANE_WIDTH, PANE_HEIGHT);

      Scene scene = new Scene(root);
      stage.setScene(scene);
      stage.setTitle("A pane with a button");
      stage.show();
   }
}


class ClickHandler implements EventHandler<ActionEvent>
{
   public void handle(ActionEvent event)
   {
      System.out.println("I was clicked.");
   }
}
