/**
   https://docs.oracle.com/javase/8/docs/api/java/awt/event/AdjustmentListener.html

   https://docs.oracle.com/javase/8/docs/api/java/awt/event/AdjustmentEvent.html
*/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Watch_Adjustment
{
   public static void main(String[] args)
   {
      JFrame jf = new JFrame("Adjustment Example");
      jf.setSize(300, 300);
      jf.setVisible(true);

      JScrollBar sbV = new JScrollBar(JScrollBar.VERTICAL,   50, 2, 0, 100);
      JScrollBar sbH = new JScrollBar(JScrollBar.HORIZONTAL, 50, 2, 0, 100);
      sbV.addAdjustmentListener(new HandleAdj());
      sbH.addAdjustmentListener(new HandleAdj());
      jf.add(sbV, BorderLayout.EAST );
      jf.add(sbH, BorderLayout.SOUTH );
   }
}


class HandleAdj implements AdjustmentListener
{
   @Override public void adjustmentValueChanged(AdjustmentEvent e){System.out.println(e+"\n");}
}
