/**
   https://docs.oracle.com/javase/8/docs/api/java/awt/event/FocusListener.html

   https://docs.oracle.com/javase/8/docs/api/java/awt/event/FocusEvent.html
*/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Watch_Focus
{
   public static void main(String[] args)
   {
      JFrame jf = new JFrame("Focus Example");
      jf.setLayout(new FlowLayout());
      jf.setSize(300, 300);
      jf.addFocusListener(new HandleF());
      jf.setVisible(true);

      //jf.add(new JLabel("A JLabel"));
      //jf.add(new JButton("Click Me")); // This takes over the focus!
   }
}

class HandleF implements FocusListener
{
   @Override public void focusGained(FocusEvent e){System.out.println(e+"\n");}
   @Override public void focusLost  (FocusEvent e){System.out.println(e+"\n");}
}
